package com.flossom.auth.controller;

import javax.servlet.http.HttpServletRequest;

import com.flossom.auth.form.LoginBody;
import com.flossom.auth.form.RegisterBody;
import com.flossom.auth.form.WxLoginBody;
import com.flossom.auth.service.SysLoginService;
import com.flossom.common.core.constant.UserConstants;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import com.flossom.common.core.domain.R;
import com.flossom.common.core.utils.JwtUtils;
import com.flossom.common.core.utils.StringUtils;
import com.flossom.common.security.auth.AuthUtil;
import com.flossom.common.security.service.TokenService;
import com.flossom.common.security.utils.SecurityUtils;
import com.flossom.system.api.model.LoginUser;

/**
 * token 控制
 *
 * @author flossom
 */
@RestController
public class TokenController
{
    @Autowired
    private TokenService tokenService;

    @Autowired
    private SysLoginService sysLoginService;

    @PostMapping("login")
    public R<?> login(@RequestBody LoginBody form)
    {
        // 用户登录
        LoginUser userInfo = sysLoginService.login(form.getUsername(), form.getPassword());
        // 获取登录token
        return R.ok(tokenService.createToken(userInfo));
    }

    @PostMapping("wxLogin")
    public R<?> wxLogin(@RequestBody WxLoginBody form)
    {
        // 用户登录
        LoginUser userInfo = sysLoginService.login(form.getOpenid(), UserConstants.WX_SYSTEM_USER_PASSWORD);
        // 设置微信用户信息
        userInfo.setWxUserMember(form);
        // 获取登录token
        return R.ok(tokenService.createToken(userInfo));
    }

    @DeleteMapping("logout")
    public R<?> logout(HttpServletRequest request)
    {
        String token = SecurityUtils.getToken(request);
        if (StringUtils.isNotEmpty(token))
        {
            String username = JwtUtils.getUserName(token);
            // 删除用户缓存记录
            AuthUtil.logoutByToken(token);
            // 记录用户退出日志
            sysLoginService.logout(username);
        }
        return R.ok();
    }

    @PostMapping("refresh")
    public R<?> refresh(HttpServletRequest request)
    {
        LoginUser loginUser = tokenService.getLoginUser(request);
        if (StringUtils.isNotNull(loginUser))
        {
            // 刷新令牌有效期
            tokenService.refreshToken(loginUser);
            return R.ok();
        }
        return R.ok();
    }

    @PostMapping("register")
    public R<?> register(@RequestBody RegisterBody registerBody)
    {
        // 用户注册
        sysLoginService.register(registerBody.getUsername(), registerBody.getPassword());
        return R.ok();
    }
}
